/* ChatController */

#import <Cocoa/Cocoa.h>

#import "WasteApplication.h"

#include "main.h"
#include "util.h"
#include "filedb.h"
#include "d_chat.h"
#include "m_chat.h"

@interface ChatController : NSObject
{
	NSLock	* chatLock;
	NSMutableArray * chatParticipants;
	NSTimer * scrollTimer;

	IBOutlet id nickNamesBrowser;
	IBOutlet id chatPanel;
	IBOutlet NSDrawer * participantDrawer;
	IBOutlet NSTextView * chatTextView;
	IBOutlet NSScrollView * chatScrollView;
	IBOutlet id chatMessageTextField;
	IBOutlet id chatStatusLabel;
	IBOutlet id toggleButton;
}

- (NSMutableArray *)chatParticipants;

- (IBAction) sendChatMessage: (id)sender;

- (void) appendToChatText: (NSString *)string;
- (void) createNewChatRoomWithChannel: (NSString *)channel;
- (void) scrollToVisible;
- (void) sendChatMessage;

- (id) chatTextView;

- (int) handleMessage: (T_Message *)message;
- (int) handleReplyMessage: (T_Message *) message;
- (void) add_chatline: (char *)line;

- (chatroom_item *) chat_ShowRoom: (char *)channel activate: (BOOL)activate;
- (void) formatChatString: (char *)txt src: (char *)src str: (char *)str chatRoom: (chatroom_item *)room;
- (void) gotNick: (char *)nick state: (int)state stateMask: (int)stateMask deliFold: (int)deliFold;
- (void) addChatParticipant: (char *)nick;
- (void) removeChatParticipant: (char *)nick;

@end
