#import "ChatController.h"

extern void debug_printf(char *, ...);
extern void main_onGotNick(char *nick, int del);
extern void main_onGotChannel(char *cnl);

#define MAX_CHATTEXT_SIZE 30000

chatroom_item *L_Chatroom;

@implementation ChatController

- init;
{
	self = [super init];
	if (!chatLock) {
		chatLock = [[NSLock alloc] init];
	}
	return self;
}

- (NSMutableArray *)chatParticipants;
{
	return chatParticipants;
}

- (void) awakeFromNib;
{
	if (!scrollTimer) {
		scrollTimer = [[NSTimer scheduledTimerWithTimeInterval: 0.5 target: self selector: (SEL)@selector(scrollToVisible) userInfo: nil repeats: YES] retain];
		[scrollTimer fire];
	}

	// Trying to make sure that the scrollview keeps up when text is added to the textview inside it
	[[chatTextView textContainer] setWidthTracksTextView: YES];

	// create chatParticipants array
	if (!chatParticipants) {
		chatParticipants = [[NSMutableArray array] retain];
	}

	// Make sure the NSBrowser delegate is set to this object
	if ([nickNamesBrowser delegate] != self) {
		[nickNamesBrowser setDelegate: self];
	}
}

- (id) chatTextView;
{
	return chatTextView;
}

- (void) addChatParticipant: (char *)nick;
{
	NSAssert(chatParticipants, @"charParticipants must not be nil");
	[chatLock lock];
	[chatParticipants addObject: [NSString stringWithCString: nick]];
	[chatLock unlock];
	[nickNamesBrowser reloadColumn: 0];
	// Why the fuck doesn't this work? User MUST click button. -- shitty
//	[toggleButton performSelector: (SEL)@selector(performClick:) withObject: nil afterDelay: 0.1];
//	[WasteApplication detachDrawingThread: (SEL)@selector(open) toTarget: participantDrawer withObject: nil];
}

- (void) removeChatParticipant: (char *)nick;
{
	NSAssert(chatParticipants, @"charParticipants must not be nil");
	[chatLock lock];
	[chatParticipants removeObject: [NSString stringWithCString: nick]];
	[chatLock unlock];
	[nickNamesBrowser reloadColumn: 0];
	// Why the fuck doesn't this work? User MUST click button. -- shitty
//	[toggleButton performSelector: (SEL)@selector(performClick:) withObject: nil afterDelay: 0.1];
//	[WasteApplication detachDrawingThread: (SEL)@selector(open) toTarget: participantDrawer withObject: nil];
}

- (void) gotNick: (char *)nick state: (int)state stateMask: (int)stateMask deliFold: (int)deliFold;
{
	debug_printf("gotNick: nick = %s, state = %d, stateMask = %d, deliFold = %d\n", nick, state, stateMask, deliFold);
 //  KillTimer(hwnd,1);
 //  SetTimer(hwnd,1,1000,NULL);

 //  HWND hwndTree=GetDlgItem(hwnd,IDC_TREE1);
 //  HTREEITEM h=TreeView_GetChild(hwndTree,TVI_ROOT);
 //  TVITEM i;
 //  int gotme=0;
 //  while (h)
 //  {
 //    char tmp[64];
 //    tmp[0]=0;
 //    i.mask=TVIF_TEXT|TVIF_PARAM|TVIF_STATE;
 //    i.hItem=h;
 //    i.pszText=tmp;
 //    i.cchTextMax=sizeof(tmp);
 //    i.state=0;
 //    i.stateMask=TVIS_BOLD;
 //    TreeView_GetItem(hwndTree,&i);
 //    if (delifold && !nick)
 //    {
 //      h=TreeView_GetNextSibling(hwndTree,h);
 //      if (!stricmp(tmp,g_regnick) && !gotme)
 //      {
 //        gotme=1;
 //      }
 //      else if (i.lParam)
 //      {
 //        int age=GetTickCount() - i.lParam;
 //        if (!(i.state&TVIS_BOLD))
 //        {
 //          if (age > 15000)
 //          {
 //            TreeView_DeleteItem(hwndTree,i.hItem);
 //            chatroom_item *cli=(chatroom_item *)GetWindowLong(hwnd,GWL_USERDATA);
 //            if (cli)
 //            {
 //              char buf[1024];
 //              sprintf(buf,"*** %s may have left %s (no response)",i.pszText,cli->channel);
 //              add_chatline(buf);
 //            }
 //          }
 //        }
 //        else
 //        {
 //          if (age > 5000)  // set it to unbold
 //          {
 //            i.mask=TVIF_HANDLE|TVIF_STATE;
 //            i.state=0;
 //            i.stateMask=TVIS_BOLD;
 //            TreeView_SetItem(hwndTree,&i);
 //          }
 //        }
 //      }
 //    }
 //    else
 //    {
 //      if (!stricmp(i.pszText,nick))
 //      {
 //        if (delifold)
 //        {
 //          TreeView_DeleteItem(hwndTree,h);
 //        }
 //        else
 //        {
 //          i.hItem=h;
 //          i.mask=TVIF_HANDLE|TVIF_PARAM|TVIF_STATE|TVIF_TEXT;
 //          i.pszText=nick;
 //          i.lParam=0;
 //          i.state=state;
 //          i.stateMask=statemask;
 //          TreeView_SetItem(hwndTree,&i);
 //        }
 //        return;
 //      }
 //      h=TreeView_GetNextSibling(hwndTree,h);
 //    }
 //  }

 //  if (!delifold)
 //  {
 //    TVINSERTSTRUCT tis;
 //    tis.hParent=TVI_ROOT;
 //    tis.hInsertAfter=TVI_SORT;
 //    tis.item.mask=TVIF_PARAM|TVIF_STATE|TVIF_TEXT;
 //    tis.item.lParam=0;
 //    tis.item.pszText=nick;
 //    tis.item.state=state;
 //    tis.item.stateMask=statemask;
 //    TreeView_InsertItem(hwndTree,&tis);
 //  }
 //  else if (!nick && !gotme)
 //  {
 //    TVINSERTSTRUCT tis;
 //    tis.hParent=TVI_ROOT;
 //    tis.hInsertAfter=TVI_SORT;
 //    tis.item.mask=TVIF_PARAM|TVIF_STATE|TVIF_TEXT;
 //    tis.item.lParam=0;
 //    tis.item.pszText=g_regnick;
 //    tis.item.state=TVIS_BOLD;
 //    tis.item.stateMask=TVIS_BOLD;
 //    TreeView_InsertItem(hwndTree,&tis);
 //  }
}

- (void) formatChatString: (char *)txt src: (char *)src str: (char *)str chatRoom: (chatroom_item *)room;
{
//	debug_printf("formatChatString: txt = %s, src = %s, str = %s, channel = %s\n", txt, src, room->channel);
	if (!room)
	{
		debug_printf("formatChatString: got chat message '%s','%s','%s', but cnl=NULL\n", txt, src, str);
		return;
	}
	if (g_chat_timestamp&(1 << (int)(room->channel[0]=='#' || room->channel[0]=='&')))
	{
		time_t t; struct tm *tm;
		t = time(NULL);
		tm = localtime(&t);
		if (tm)
		{
			if (g_chat_timestamp&4)
				txt+=sprintf(txt,"[%d/%d/%02d@%02d:%02d:%02d] ",
				 tm->tm_mon+1,tm->tm_mday,tm->tm_year%100,
				 tm->tm_hour,tm->tm_min, tm->tm_sec);
			else
				txt+=sprintf(txt,"[%02d:%02d:%02d] ",tm->tm_hour,tm->tm_min, tm->tm_sec);
		}
	}

	if (!strncmp(str,"/nick/",6) && str[6])
	{
		if (room->channel[0] == '#' || room->channel[0] == '&')
		{
			sprintf(txt,"*** %s is now known as %s",str+6,src);
			[self gotNick: str+6 state: 0 stateMask: 0 deliFold: 1];
		}
		else
		{
			if (str[6] == '#' || str[6] == '&')
			{
				strcpy(txt,"*** invalid message received");
			}
			else
			{
				sprintf(txt,"*** %s is now known as %s",str+6,src);
				safe_strncpy(room->channel,src,sizeof(room->channel));
				//        SendMessage(room->hwnd,WM_USER_TITLEUPDATE,0,0);
			}
		}
	}
	else if (!strncmp(str,"/iam/",5))
	{
		if (strlen(str)>255) str[255]=0;
		sprintf(txt,"*** %s is %s",src,str+5);
	}
	else if (!strcmp(str,"/join"))
	{
		if (room->channel[0] == '#' || room->channel[0] == '&')
		{
			[self addChatParticipant: src];
			sprintf(txt,"*** %s has joined %s",src,room->channel);
		}
		else strcpy(txt,"*** invalid message received");
	}
	else if (!strcmp(str,"/leave"))
	{
		if (room->channel[0] == '#' || room->channel[0] == '&')
		{
			[self removeChatParticipant: src];
			sprintf(txt,"*** %s has left %s",src,room->channel);
		}
		else strcpy(txt,"*** invalid message received");
	}
	else if (!strnicmp(str,"/me ",4)) sprintf(txt,"* %s %s",src,str+4);
	else if (!strncmp(str,"//",2)) sprintf(txt,"<%s> %s",src,str+1);
	else if (str[0] != '/')
	{
		sprintf(txt,"<%s> %s",src,str);
	}
	else txt[0]=0;
}

- (chatroom_item *)chat_ShowRoom: (char *)channel activate: (BOOL)activate;
{
	int n = 0;
	chatroom_item *p = L_Chatroom;
	debug_printf("chat_ShowRoom: channel = %s, activate = %d\n", channel, activate);
	if (!p) {
		debug_printf("chat_ShowRoom: - Chat room is empty\n");
	}
	while (p!=NULL)
	{
		if(!stricmp(p->channel,channel))
		{
			if (activate)
			{
				[(id)p->hwnd makeKeyAndOrderFront: nil];
			}
			return p;
		}
		p=p->next;
		n++;
	}

	if (g_config->ReadInt("limitchat",1) && g_config->ReadInt("limitchatn",64) <= n)
	{
		return NULL;
	}

	chatroom_item *cli=(chatroom_item *)malloc(sizeof(chatroom_item));
	memset(cli,0,sizeof(chatroom_item));
	if (channel[0] == '#' || channel[0] == '&')
	{
		if (channel[0] == '#') main_onGotChannel(channel);
	}
	else
	{
		// private / hidden channel
	}
	strcpy(cli->channel,channel);
	cli->next = L_Chatroom;
	L_Chatroom = cli;

	return cli;
}

- (int) handleMessage: (T_Message *)message;
{
	chatroom_item *p=L_Chatroom;
	debug_printf("Chat Reply Message received: %d\n", MESSAGE_CHAT_REPLY);
	if (message->message_type == MESSAGE_CHAT_REPLY)
	{
		C_MessageChatReply repl(message->data);
		char *n=repl.getnick();
		if (strlen(n) < 24 && n[0] && n[0] != '.') main_onGotNick(n,0);
		while(p!=NULL)
		{
			if(!memcmp(&p->lastMsgGuid,&message->message_guid,16))
			{
				if (n[0])
				{
					// see if nick is already in list
					if (p->channel[0] == '#' || p->channel[0] == '&')
					{
						[self gotNick: n state: 0 stateMask: 0 deliFold: 0];
					}
					else
					{
						char buf[1024];
						char *tmp="Message sent, delivery confirmed";
						strcpy(buf, [[chatStatusLabel stringValue] cString]);
						if (strncmp(buf,tmp,strlen(tmp)))
						{
							sprintf(buf,"%s - (%dms roundtrip)", tmp, GetTickCount()-p->lastmsgguid_time);
						}
						else
						{
							int a=1;
							char *q=buf+strlen(tmp)+1;
							if (*q == '(') a=atoi(q+1);
							sprintf(buf,"%s (%d recipients) - (%dms max roundtrip).",tmp,a+1,GetTickCount()-p->lastmsgguid_time);
						}
						[chatStatusLabel setStringValue: [NSString stringWithCString: buf]];
					}
				}
				break;
			}
			p=p->next;
		}
		return !!p;
	}
	int retval=0;
	C_MessageChat chat(message->data);
	char *cnl=chat.get_dest();
	{
		char *n=chat.get_src();
		if (n[0] && strlen(n)<24 && n[0] != '.')
			main_onGotNick(n,0);
	}
	if (cnl && *cnl == '#')
	{
		main_onGotChannel(cnl);
	}

	if (!strcmp(chat.get_chatstring(),"/whois"))
	{
		if (!stricmp(chat.get_dest(),g_regnick) && g_regnick[0])
		{
			char buf[256+512+32];
			sprintf(buf,"/iam/%s (%s",g_config->ReadString("userinfo",APP_NAME " User"),g_nameverstr);
			int length=0;
			if (g_database) length=g_database->GetNumMB();
			else if (g_newdatabase) length=g_newdatabase->GetNumMB();

			if (length)
			{
				if (length < 1024)
					sprintf(buf+strlen(buf),", %u MB public",length);
				else sprintf(buf+strlen(buf),", %u.%u GB public",length>>10,((length%1024)*10)/1024);
			}
			strcat(buf,")");
			C_MessageChat req;
			req.set_chatstring(buf);
			req.set_dest(chat.get_src());
			req.set_src(g_regnick);
			T_Message msg;
			msg.data=req.Make();
			msg.message_type=MESSAGE_CHAT;
			if (msg.data)
			{
				msg.message_length=msg.data->GetLength();
				g_mql->send(&msg);
			}
		}
		return 0;
	}

	if (!strncmp(chat.get_chatstring(),"/nick/",6) && chat.get_chatstring()[6] && !strcmp(chat.get_dest(),"&"))
	{
		main_onGotNick(chat.get_chatstring()+6,1);
		int isgood=0;

		if (chat.get_chatstring()[6] != '#' && chat.get_chatstring()[6] != '&') while(p!=NULL)
		{
			if (p->channel[0] == '#' || p->channel[0] == '&')
			{
// This is meant to highlight (in bold) the nick name that send the chat message
//				if (!stricmp(tx,chat.get_chatstring()+6))
//				{
//					isgood=1;
//					gotNick(chat.get_src(),0,0,0);	// Bold the nick name
//					break;
//				}
			}
		}

		if (isgood || !stricmp(p->channel,chat.get_chatstring()+6))
		{
			char txt[4096];
			[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
			//formatChatString(txt,chat.get_src(),chat.get_chatstring(),p);
			if (txt[0]) [self add_chatline: txt];
			retval=1;
		}
		p=p->next;
		return 0;
	}

#if 0
	while(p!=NULL)
	{
		if (!strcmp(p->channel,"/sniff/"))
		{
			char txt[4096];
			sprintf(txt,"<%s/%s>: %s",chat.get_src(),chat.get_dest(),chat.get_chatstring());
			[self add_chatline: [NSString stringWithCString: txt]];
			break;
		}
		p=p->next;
	}
	p=L_Chatroom;
#endif

	if (g_regnick[0] && !stricmp(cnl,g_regnick)) // privmsg
	{
		while(p!=NULL)
		{
			if(!stricmp(p->channel,chat.get_src()))
			{
				char txt[4096];
				[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
				if (txt[0]) 
				{
					[self add_chatline: txt];
					int f=g_config->ReadInt("flashchatwindow",65);
					if (f&1) debug_printf("flashchatwindow = %d\n", f);
#ifdef _WIN32
					if (f&1) DoFlashWindow(p->hwnd,(f&2)?f/4:0);
#endif
					retval=1;
				}
				break;
			}
			p=p->next;
		}
		if (!p && g_config->ReadInt("allowpriv",1)) // time to create a privchat
		{
			char txt[4096];
			p = [self chat_ShowRoom: chat.get_src() activate: YES];
			[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
			if (txt[0])
			{
				[self add_chatline: txt];
				int f=g_config->ReadInt("flashchatwindow",65);
				if (f&1) debug_printf("flashchatwindow = %d\n", f);
#ifdef _WIN32
				if (f&1) DoFlashWindow(p->hwnd,(f&2)?f/4:0);
#endif
				retval=1;
			}
		}
	}
	else if (cnl[0] == '#' || cnl[0] == '&')
	{
		while(p!=NULL)
		{
			if(!stricmp(p->channel,cnl))
			{
				char txt[4096];
				[self gotNick: chat.get_src() state: 0 stateMask: 0 deliFold: !strcmp(chat.get_chatstring(),"/leave")];
				[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
//				formatChatString(txt,chat.get_src(),chat.get_chatstring(),p);
				if (txt[0]) 
				{
					[self add_chatline: txt];
					int f=g_config->ReadInt("flashwindow",64);
					if (f&1) debug_printf("flashwindow = %d\n", f);
#ifdef _WIN32
					if (f&1) DoFlashWindow(p->hwnd,(f&2)?f/4:0);
#endif
					retval=1;
				}
				break;
			}
			p=p->next;
		}
	}
	return retval;
}

- (int) handleReplyMessage: (T_Message *) message;
{
	chatroom_item *p=L_Chatroom;
	debug_printf("Chat Reply Message received: %d\n", MESSAGE_CHAT_REPLY);
	if (message->message_type == MESSAGE_CHAT_REPLY)
	{
		C_MessageChatReply repl(message->data);
		char *n=repl.getnick();
		if (strlen(n) < 24 && n[0] && n[0] != '.') main_onGotNick(n,0);
		while(p!=NULL)
		{
			if(!memcmp(&p->lastMsgGuid,&message->message_guid,16))
			{
				if (n[0])
				{
					// see if nick is already in list
					if (p->channel[0] == '#' || p->channel[0] == '&')
					{
						[self gotNick: n state: 0 stateMask: 0 deliFold: 0];
					}
					else
					{
						char buf[128];
						char *tmp="Message sent, delivery confirmed";
						// [... stringValue] GetDlgItemText(p->hwnd,IDC_STATUS,buf,sizeof(buf));
						if (strncmp(buf,tmp,strlen(tmp)))
						{
							sprintf(buf,"%s - (%dms roundtrip)",tmp,GetTickCount()-p->lastmsgguid_time);
						}
						else
						{
							int a=1;
							char *q=buf+strlen(tmp)+1;
							if (*q == '(') a=atoi(q+1);
							sprintf(buf,"%s (%d recipients) - (%dms max roundtrip).",tmp,a+1,GetTickCount()-p->lastmsgguid_time);
						}
						// SetDlgItemText(p->hwnd,IDC_STATUS,buf);
					}
				}
				break;
			}
			p=p->next;
		}
		return !!p;
	}
	int retval=0;
	C_MessageChat chat(message->data);
	char *cnl=chat.get_dest();
	{
		char *n=chat.get_src();
		if (n[0] && strlen(n)<24 && n[0] != '.')
			main_onGotNick(n,0);
	}
	if (cnl && *cnl == '#')
	{
		main_onGotChannel(cnl);
	}

	if (!strcmp(chat.get_chatstring(),"/whois"))
	{
		if (!stricmp(chat.get_dest(),g_regnick) && g_regnick[0])
		{
			char buf[256+512+32];
			sprintf(buf,"/iam/%s (%s",g_config->ReadString("userinfo",APP_NAME " User"),g_nameverstr);
			int length=0;
			if (g_database) length=g_database->GetNumMB();
			else if (g_newdatabase) length=g_newdatabase->GetNumMB();

			if (length)
			{
				if (length < 1024)
					sprintf(buf+strlen(buf),", %u MB public",length);
				else sprintf(buf+strlen(buf),", %u.%u GB public",length>>10,((length%1024)*10)/1024);
			}
			strcat(buf,")");
			C_MessageChat req;
			req.set_chatstring(buf);
			req.set_dest(chat.get_src());
			req.set_src(g_regnick);
			T_Message msg;
			msg.data=req.Make();
			msg.message_type=MESSAGE_CHAT;
			if (msg.data)
			{
				msg.message_length=msg.data->GetLength();
				g_mql->send(&msg);
			}
		}
		return 0;
	}

	if (!strncmp(chat.get_chatstring(),"/nick/",6) && chat.get_chatstring()[6] && !strcmp(chat.get_dest(),"&"))
	{
		main_onGotNick(chat.get_chatstring()+6,1);

		if (chat.get_chatstring()[6] != '#' && chat.get_chatstring()[6] != '&') while(p!=NULL)
		{
			int isgood=0;
			if (p->channel[0] == '#' || p->channel[0] == '&')
			{
				[self gotNick: chat.get_src() state: 0 stateMask: 0 deliFold: 0];
			}

			if (isgood || !stricmp(p->channel,chat.get_chatstring()+6))
			{
				char txt[4096];
				[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
//				formatChatString(txt,chat.get_src(),chat.get_chatstring(),p);
				if (txt[0]) [self add_chatline: txt];
				retval=1;
			}
			p=p->next;
		}
			return 0;
	}

#if 0
	while(p!=NULL)
	{
		if (!strcmp(p->channel,"/sniff/"))
		{
			char txt[4096];
			sprintf(txt,"<%s/%s>: %s",chat.get_src(),chat.get_dest(),chat.get_chatstring());
			[self add_chatline: txt];
			break;
		}
		p=p->next;
	}
	p=L_Chatroom;
#endif

	if (g_regnick[0] && !stricmp(cnl,g_regnick)) // privmsg
	{
		while(p!=NULL)
		{
			if(!stricmp(p->channel,chat.get_src()))
			{
				char txt[4096];
				[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
//				formatChatString(txt,chat.get_src(),chat.get_chatstring(),p);
				if (txt[0])
				{
					[self add_chatline: txt];
					int f=g_config->ReadInt("flashchatwindow",65);
					if (f&1) debug_printf("flashchatwindow = %d\n", f);
#ifdef _WIN32
					if (f&1) DoFlashWindow(p->hwnd,(f&2)?f/4:0);
#endif
					retval=1;
				}
				break;
			}
			p=p->next;
		}
		if (!p && g_config->ReadInt("allowpriv",1)) // time to create a privchat
		{
			char txt[4096];
			p = [self chat_ShowRoom: chat.get_src() activate: YES];
//			p=chat_ShowRoom(chat.get_src(),1);
			[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
//			formatChatString(txt,chat.get_src(),chat.get_chatstring(),p);
			if (txt[0])
			{
				[self add_chatline: txt];
				int f=g_config->ReadInt("flashchatwindow",65);
				if (f&1) debug_printf("d_chat: flashchatwindow = %d\n", f);
#ifdef _WIN32
				if (f&1) DoFlashWindow(p->hwnd,(f&2)?f/4:0);
#endif
				retval=1;
			}
		}
	}
	else if (cnl[0] == '#' || cnl[0] == '&')
	{
		while(p!=NULL)
		{
			if(!stricmp(p->channel,cnl))
			{
				char txt[4096];
				[self gotNick: chat.get_src() state: 0 stateMask: 0 deliFold: !strcmp(chat.get_chatstring(),"/leave")];
				[self formatChatString: txt src: chat.get_src() str: chat.get_chatstring() chatRoom: p];
//				formatChatString(txt,chat.get_src(),chat.get_chatstring(),p);
				if (txt[0])
				{
					[self add_chatline: txt];
					int f=g_config->ReadInt("flashwindow",64);
					if (f&1) debug_printf("d_chat: flashwindow = %d\n", f);
#ifdef _WIN32
					if (f&1) DoFlashWindow(p->hwnd,(f&2)?f/4:0);
#endif
					retval=1;
				}
				break;
			}
			p=p->next;
		}
	}
	return retval;
}

- (void) add_chatline: (char *)line;
{
	//	NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	//  HWND m_hwnd=GetDlgItem(hwndDlg,IDC_CHATTEXT);
 //  SCROLLINFO si={sizeof(si),SIF_RANGE|SIF_POS|SIF_TRACKPOS,};
 //  GetScrollInfo(m_hwnd,SB_VERT,&si);

	debug_printf("add_chatline : line = %s\n", line);
	if (line)
	{
		[self appendToChatText: [NSString stringWithCString: line]];
//		int isurl=0;
//		if (*t == '#' || *t == '&') isurl=1;
//		else if (!strnicmp(t,"waste:",6)) isurl=6;
//		else if (!strnicmp(t,"http:",5)) isurl=5;
//		else if (!strnicmp(t,"ftp:",4)) isurl=4;
//		else if (!strnicmp(t,"www.",4)) isurl=4;
	}
}

- (IBAction)sendChatMessage:(id)sender;
{
	[self sendChatMessage];
}

- (void) sendChatMessage;
{
	if(!g_regnick[0])
	{
		[self add_chatline: "Register your nickname first !"];
		[chatStatusLabel setStringValue: @""];
		return;
	}
	{
		int isme=0;
		chatroom_item *cli = L_Chatroom; //=(chatroom_item *)GetWindowLong(hwndDlg,GWL_USERDATA);
		char buf[2048];
		safe_strncpy(buf, (char *)[[chatMessageTextField stringValue] cString], sizeof(buf));
		char *text = buf;
		while (*text == ' ') text++;
		if (text[0] == '/' && text[1] != '/')
		{
			if (text[1] == 'J' || text[1] == 'j')
			{
				while (*text && *text != ' ') text++;
				while (*text == ' ') text++;
				if(strstr(text,"\r") || strstr(text,"\n") || (*text != '#' && *text != '&'))
				{
					[self add_chatline: "Usage: /join <#channel|&channel>"];
				}
				else
				{
					L_Chatroom = [self chat_ShowRoom: text activate: YES];
//					L_Chatroom = chat_ShowRoom(text,1);
					[chatStatusLabel setStringValue: @""];
					return;
				}
			}
			else if (!strnicmp(text+1,"whois",5))
			{
				while (*text && *text != ' ') text++;
				while (*text == ' ') text++;
				if(!*text || strstr(text,"\r") || strstr(text,"\n") || strstr(text,"#") || strstr(text,"&"))
				{
					[self add_chatline: "Usage: /whois <username>"];
				}
				else
				{
					T_Message msg;
					// send a message to text that is /whois
					C_MessageChat req;
					req.set_chatstring("/whois");
					req.set_dest(text);
					req.set_src(g_regnick);
					msg.data=req.Make();
					msg.message_type=MESSAGE_CHAT;
					if (msg.data)
					{
						msg.message_length=msg.data->GetLength();
						g_mql->send(&msg);
					}
				}
			}
			else if (!strnicmp(text+1,"search",6))
			{
				while (*text && *text != ' ') text++;
				while (*text == ' ') text++;
				if(!*text || strstr(text,"\r") || strstr(text,"\n"))
				{
					[self add_chatline: "Usage: /search <searchterm>"];
				}
				else
				{
//							SendMessage(g_mainwnd,WM_COMMAND,IDC_SEARCH,0);
//							Search_Search(text);
					[chatStatusLabel setStringValue: @""];
					return;
				}
			}
			else if (!strnicmp(text+1,"browse",6))
			{
				while (*text && *text != ' ') text++;
				while (*text == ' ') text++;
				if(!*text || strstr(text,"\r") || strstr(text,"\n"))
				{
					[self add_chatline: "Usage: /browse <user|path>"];
				}
				else
				{
					if (*text != '/') 
					{
						text--;
						*text='/';
					}
//							SendMessage(g_mainwnd,WM_COMMAND,IDC_SEARCH,0);
//							Search_Search(text);
					[chatStatusLabel setStringValue: @""];
					return;
				}
			}
			else if (!strnicmp(text+1,"leave",5))
			{
				// "adjust UI" PostMessage(hwndDlg,WM_CLOSE,0,0);
			}
			else if (!strnicmp(text+1,"clear",5))
			{
				[chatStatusLabel setStringValue: @""];
			}
			else if (!strnicmp(text+1,"query",5))
			{
				while (*text && *text != ' ') text++;
				while (*text == ' ') text++;
				if (!strstr(text,"\r") && !strstr(text,"\n") && *text && text[0] != '#' && text[0] != '&')
				{
					[self chat_ShowRoom: text activate: YES];
//					chat_ShowRoom(text,1);
					[chatStatusLabel setStringValue: @""];
					return;
				}
				else
				{
					[self add_chatline: "Usage: /query <nickname>"];
				}
			}
			else if (!strnicmp(text+1,"me",2))
			{
				if (!strstr(text,"\r") && !strstr(text,"\n") && text[3]==' ' && text[4]) 
				{
					isme=1;
					goto senditanyway;
				}
				[self add_chatline: "Usage: /me <action>"];
			}
			else if (!strnicmp(text+1,"msg",3))
			{
				char *dstr;
				if (!strstr(text,"\r") && !strstr(text,"\n") && text[4] == ' ' && text[5] && text[5] != ' ' && (dstr=strstr(text+5," ")) )
				{
					T_Message msg={{0},0};
					C_MessageChat req;
					// dstr is the string we are sending
					if (dstr[1] == '/') 
					{
						dstr[0]='/';
						req.set_chatstring(dstr);
					}
					else
					{
						req.set_chatstring(dstr+1);
					}
					*dstr=0;

					req.set_dest(text+5);
					req.set_src(g_regnick);
					msg.data=req.Make();
					msg.message_type=MESSAGE_CHAT;
					if (msg.data)
					{
						msg.message_length=msg.data->GetLength();
						g_mql->send(&msg);
						char tmp[4096];
						sprintf(tmp,"-> *%s*: %s",text+5,dstr+1);
						[self add_chatline: tmp];
					}
				}
				else
					[self add_chatline: "Usage: /msg <user> <text>"];
			}
			else if (!strnicmp(text+1,"help",4))
			{
				[self add_chatline: "Commands:"];
				[self add_chatline: "  /msg <user> <text>"];
				[self add_chatline: "  /query <user>"];
				[self add_chatline: "  /whois <user>"];
				[self add_chatline: "  /join <channel>"];
				[self add_chatline: "  /me <action>"];
				[self add_chatline: "  /search <searchterm>"];
				[self add_chatline: "  /browse <user|path>"];
				[self add_chatline: "  /leave"];
				[self add_chatline: "  /clear"];
			}
			else
			{
				[self add_chatline: "Unknown command! Try /help"];
			}
		}           
		else if (strlen(text)>0)
		{
senditanyway:
			if (cli->channel[0] == '#' || cli->channel[0] == '&')
			{
				// public chat channel
			}
			else
			{
				[chatStatusLabel setStringValue: @"Sent message, awaiting reply"];
			}

			int l=0;
			while (text && *text && l++ < 16)
			{
				while (*text == '\r' || *text == '\n') text++;
				while (*text == ' ') text++;

				char *lasttext=text;
				while (*text && *text != '\r' && *text != '\n') text++;
				if (*text) *text++=0;
				if (!*lasttext) break;

				T_Message msg={{0},0};
				C_MessageChat req;

				char buf[1024];
				if (lasttext[0] == '/' && lasttext[1] != '/' && !isme)
				{
					safe_strncpy(buf+1,lasttext,sizeof(buf)-1);
					buf[0]='/';
				}
				else 
				{
					safe_strncpy(buf,lasttext,sizeof(buf));
				}
				isme=0;
				req.set_chatstring(buf);

				req.set_dest(cli->channel);
				req.set_src(g_regnick);
				msg.data=req.Make();
				msg.message_type=MESSAGE_CHAT;
				if (msg.data)
				{
					msg.message_length=msg.data->GetLength();
					g_mql->send(&msg);
					cli->lastMsgGuid=msg.message_guid;
					cli->lastmsgguid_time=GetTickCount();
					char tmp[4096];
					[self formatChatString: tmp src: req.get_src() str: buf chatRoom: cli];
//					formatChatString(tmp,req.get_src(),buf,cli);
					if (tmp[0]) [self add_chatline: tmp];
				}
			}
			[chatStatusLabel setStringValue: @""];
		}
//		[chatMessageTextField setStringValue: @""];
//		[chatMessageTextField selectText: nil];
	}
//	[self appendToChatText: [NSString stringWithFormat: @"%@\n", [sender stringValue]]];
	[chatMessageTextField setStringValue: @""];
	[chatMessageTextField selectText: self];
}

- (void)createNewChatRoomWithChannel: (NSString *)channel;
{
	if (!chatPanel) {
		[NSBundle loadNibNamed: @"ChatWindow.nib" owner: self];
		NSAssert(chatPanel, @"chatPanel should not be nil");
	}
	chatroom_item *p = [self chat_ShowRoom: (char *)[channel cString] activate: YES];
//	chatroom_item *p=chat_ShowRoom((char *)[channel cString], 1);
	if (p) {
		[chatPanel setTitle: [NSString stringWithFormat: @"Chat - %@", channel]];
		[chatPanel makeKeyAndOrderFront: nil];
		[chatMessageTextField setStringValue: @""];
		[chatMessageTextField selectText: self];
		p->hwnd = chatPanel;
		L_Chatroom=p;
	}
}

- (void)scrollToVisible;
{
	if ([chatTextView string]) {
		[chatTextView scrollRangeToVisible: NSMakeRange([[chatTextView string] length]-1, 1)];
		[chatTextView setNeedsDisplay: YES];
		[chatScrollView setNeedsDisplay: YES];
		[chatScrollView reflectScrolledClipView: [chatScrollView contentView]];
	}
}

- (void)appendToChatText: (NSString *)string;
{
//	[chatLock lock];
    [chatTextView setString: [NSString stringWithFormat: @"%@\n%@", [chatTextView string], string]];
//	[chatLock unlock];
    [self performSelector: (SEL)@selector(scrollToVisible) withObject: nil afterDelay: 0.1];
}

//////////////////////////////////////////////////////////////////////////////
// NSBrowser delegate methods
//////////////////////////////////////////////////////////////////////////////

- (int)browser: (NSBrowser *)browser numberOfRowsInColumn: (int)column;
{
#ifdef _DEBUG_
//	NSLog(@"%@ - browser: %@ numberOfRowsInColumn: %d", [self class], browser, column);
#endif
	NSAssert(chatParticipants, @"chatParticipants must not be nil");
	int count = [chatParticipants count];
	return count;
}

- (void)browser: (NSBrowser *)browser willDisplayCell: (id)cell atRow: (int)row column: (int)column;
{
#ifdef _DEBUG_
//	NSLog(@"%@ - browser: %@ willDisplayCell: %@ atRow: %d column: %d", [self class], browser, cell, row, column);
#endif
	NSString *nick = nil;
	NSAssert(chatParticipants != nil, @"chatParticipants array should not be nil");
	NSAssert((unsigned)row < [chatParticipants count], @"row is out of bounds of chatParticipants array");
	nick = [chatParticipants objectAtIndex: row];
	NSAssert(nick != nil, @"nick string should not be nil");
	[cell setStringValue: nick];
	if ([cell image] == nil) {
		[cell setImage: [NSImage imageNamed: @"user.ico"]];
	}
	if ([cell isLeaf] == NO) {
		[cell setLeaf: YES];
	}
}

- (void)dealloc;
{
#ifdef _DEBUG_
	NSLog(@"%@ - dealloc", [self class]);
#endif
	[chatLock release];
	[chatParticipants release];
	[scrollTimer invalidate];
	[scrollTimer release];
	[super dealloc];
}

@end
