/* SetupController */

#import <Cocoa/Cocoa.h>

@interface SetupController : NSObject
{

	NSMutableDictionary * windowSizes;
	NSLock * keygenLock;

	BOOL should_quit;
	BOOL needs_random_numbers;

	IBOutlet id mainWindow;
	IBOutlet NSBox * mainView;

	IBOutlet NSBox * identityView;
	IBOutlet NSBox * passphraseView;
	IBOutlet NSBox * randomView;
	IBOutlet NSBox * keygenView;
	IBOutlet NSBox * profileView;

    IBOutlet id identityPanel;
    IBOutlet id nickNameTextField;
    IBOutlet id realNameTextField;
    IBOutlet id connectionSpeedPopup;
    IBOutlet id networkNameTextField;

    IBOutlet id passphrasePanel;
    IBOutlet id passphraseTextField;
    IBOutlet id passphraseAgainTextField;
    IBOutlet id keySizePopup;

    IBOutlet id randomPanel;
    IBOutlet id randomProgressBar;
    IBOutlet id randomNextButton;
    IBOutlet id randomCancelButton;
    IBOutlet id randomLabel;
    IBOutlet id randomNote;

    IBOutlet id keygenPanel;
	IBOutlet id keygenImportPrivateKeyButton;
	IBOutlet id keygenImportPublicKeyButton;
	IBOutlet id keygenImportKeyTextField;
	IBOutlet id keygenRunKeyGenButton;
	IBOutlet id keyNotLoadedLabel;
	IBOutlet id keysLoadedLabel;
	IBOutlet id keygenAuxView;

    IBOutlet id profilePanel;
    IBOutlet id databasePathTextField;
    IBOutlet id databasePathAddButton;
    IBOutlet id downloadDirectoryButton;
}

int keygen(NSLock * keygenLock);

- (void)setShouldQuit: (BOOL)aFlag;

- (BOOL)shouldQuit;

- (void)setNeedsRandomNumbers: (BOOL)aFlag;

- (BOOL)needsRandomNumbers;

- (IBAction)quit:(id)sender;

- (IBAction)cancel:(id)sender;

- (IBAction)run:(id)sender;

- (IBAction)showIdentity:(id)sender;
- (BOOL)validateIdentity;

- (IBAction)showKeygen:(id)sender;

- (IBAction)showPassphrase:(id)sender;
- (BOOL)validatePassphrase;

- (IBAction)showProfile:(id)sender;
- (BOOL)validateProfile;

- (IBAction)showRandom:(id)sender;

- (IBAction)runKeyGenerator:(id)sender;

- (IBAction)copyPublicKeyToClipboard:(id)sender;

- (IBAction)importKeyFromFile:(id)sender;
- (IBAction)importKeyText:(id)sender;
- (IBAction)importPublicKeys:(id)sender;

- (IBAction)setDownloadDirectory:(id)sender;

- (IBAction)addToDatabasePath:(id)sender;

- (void)awakeFromNib;

- (void)generateRandomAndKey;

- (void)finishProgressBar;

- (void)setProgressBar: (NSNumber *) number;

- (void)setNoteString: (NSString *) string;

@end
