//
//  StatsController.m
//  Waste
//
//  Created by Randy Antler on Mon Jun 02 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "StatsController.h"

#include "platform.h"
#include "main.h"
#include "rsa/global.h"
#include "rsa/md5.h"
extern "C" {
#include "rsa/r_random.h"
};
#include "mqueue.h"
#include "mqueuelist.h"

extern C_MessageQueueList *g_mql;
extern void debug_printf(char *, ...);

@implementation StatsController

- (void) awakeFromNib;
{
	if (!timer) {
		timer = [[NSTimer scheduledTimerWithTimeInterval: 3.0 target: self selector: (SEL)@selector(updateStats) userInfo: nil repeats: YES] retain];
		[timer fire];
	}
}

- (IBAction) showStats:(id)sender;
{
	[netStatsPanel makeKeyAndOrderFront: self];
	[self updateStats];
}

- (void) updateStats;
{
	int i;
	int sumcnt = 0;
	double sumbytes = 0.0;

	for (i = 0; i < MSGTYPE_MAX; i++) {
		int n = g_mql->getMsgCounts(i);
		sumbytes += g_mql->getMsgBytes(i) + (double)(n * MESSAGE_HEADERSZ);
		sumcnt += n;
	}
	[netStatsMsgLabel setStringValue: [NSString stringWithFormat: @"%d messages received, %.0lf bytes", sumcnt, sumbytes]];

	for (i = 0;i < MSGTYPE_MAX; i++) {
		id cell = nil;
		switch (i) {
			case MESSAGE_LOCAL_CAPS:
				cell = [netStatsForm cellAtIndex: 0];
				break;
			case MESSAGE_UPLOAD:
				cell = [netStatsForm cellAtIndex: 1];
				break;
			case MESSAGE_CHAT:
				cell = [netStatsForm cellAtIndex: 2];
				break;
			case MESSAGE_CHAT_REPLY:
				cell = [netStatsForm cellAtIndex: 3];
				break;
			case MESSAGE_KEYDIST:
				cell = [netStatsForm cellAtIndex: 4];
				break;
			case MESSAGE_KEYDIST_REPLY:
				cell = [netStatsForm cellAtIndex: 5];
				break;
			case MESSAGE_PING:
				cell = [netStatsForm cellAtIndex: 6];
				break;
			case MESSAGE_SEARCH:
				cell = [netStatsForm cellAtIndex: 7];
				break;
			case MESSAGE_SEARCH_REPLY:
				cell = [netStatsForm cellAtIndex: 8];
				break;
			case MESSAGE_SEARCH_USERLIST:
				cell = [netStatsForm cellAtIndex: 9];
				break;
			case MESSAGE_FILE_REQUEST:
				cell = [netStatsForm cellAtIndex: 10];
				break;
			case MESSAGE_FILE_REQUEST_REPLY:
				cell = [netStatsForm cellAtIndex: 11];
				break;
			case MESSAGE_LOCAL_SATURATE:
				cell = [netStatsForm cellAtIndex: 12];
				break;
			case MSGTYPE_MAX-1:	// UNKNOWN
				cell = [netStatsForm cellAtIndex: 13];
				break;
		}
//		char buf[2048];
		double b = g_mql->getMsgBytes(i);
//		sprintf(buf, "%6d msgs %9lf bytes %3lf%% total", g_mql->getMsgCounts(i), b, (sumbytes<=0.0) ? 0 : ((100.0*b)/sumbytes+0.5));
		[cell setStringValue: [NSString stringWithFormat: @"%6d msgs %9.0lf bytes %3.0lf%% total", g_mql->getMsgCounts(i), b, (sumbytes<=0.0) ? 0 : ((100.0*b)/sumbytes+0.5)]];
	}
	[netStatsLabel setStringValue: [NSString stringWithFormat: @"%d nodes, %d files, %dMB", g_mql->getMsgNodes(), g_mql->getMsgNumFiles(), g_mql->getMsgNumMB()]];
}

- (void) dealloc;
{
	[timer invalidate];
	[timer release];
}

@end
