
#import <Cocoa/Cocoa.h>

#import "GetPassphrase.h"
#import "SetupController.h"
#import "PrefsController.h"
#import "StatsController.h"

@class ClientController;
@class ChatController;

@interface WasteApplication : NSApplication
{
	NSString * publicKey;
	NSTimer * activityTimer;
	BOOL is_setting_up;

	IBOutlet ClientController * clientController;
	IBOutlet GetPassphrase * passphraseController;
    IBOutlet SetupController * setupController;
    IBOutlet PrefsController * prefsController;
    IBOutlet StatsController * statsController;
    IBOutlet ChatController * chatController;

	IBOutlet id mainWindow;
}

+ (WasteApplication *)sharedApplication;

- (ClientController *) clientController;
- (SetupController *) setupController;
- (ChatController *) chatController;

- (void) setIsSettingUp: (BOOL)aFlag;

- (IBAction) setup: (id)sender;
- (IBAction) start: (id)sender;
- (IBAction) stop: (id)sender;
- (IBAction) setPrefs: (id)sender;
- (IBAction) showStats: (id)sender;
- (IBAction) showUsers: (id)sender;
- (IBAction) showJoinChat:(id)sender;
- (IBAction) showNetworkStatus:(id)sender;
- (IBAction) showBrowser:(id)sender;
- (IBAction) showTransfers:(id)sender;
- (IBAction) showConsole:(id)sender;

- (const char *) getPassphrase;
- (void) gotNick: (NSString *) nick;
- (void) gotChannel: (NSString *) channel;

- (void) startWASTE;
- (void) stopWASTE;

- (void) spawnServer;

- (void) performSetup;

- (void) updateStatus;

- (void) copyPublicKeyToPasteboard: (NSString *)theKey;

- (BOOL) shouldShowMenuItem: (id)anItem;

@end
