/*
    WASTE - pubkey.cpp (public key generation)
    Copyright (C) 2003 Nullsoft, Inc.

    WASTE is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    WASTE  is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with WASTE; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <string.h>
#include <stdlib.h>
#include "rsa/global.h"
#include "rsa/rsaref.h"
#include "util.h"
#include "pubkey.h"

extern void debug_printf(char *, ...);

char *genMyPubKey(char nick[32], R_RSA_PRIVATE_KEY *kp)
{
  int ks=(kp->bits+7)/8;
  char *abuf, buf[(MAX_RSA_MODULUS_LEN/8)*2*2+4096];
  if (!ks) return 0;
  buf[0]=0;

  memset(buf, 0, sizeof(buf));
#ifdef _WIN32
#else
  debug_printf("bits=%d nick=%s\n", kp->bits, nick);
#endif
  sprintf(buf+strlen(buf),"WASTE_PUBLIC_KEY 20 %d %s\r\n",kp->bits,nick[0]?nick:"unknown");

  int x;
  int lc=0;
  for (x = 0; x < ks; x ++)
  {
    sprintf(buf+strlen(buf),"%02X",kp->modulus[MAX_RSA_MODULUS_LEN-ks+x]);
    if (++lc % 30 == 0) sprintf(buf+strlen(buf),"\r\n");
  }

  int zeroes;
  for (zeroes = MAX_RSA_MODULUS_LEN-ks; zeroes < MAX_RSA_MODULUS_LEN && !kp->publicExponent[zeroes]; zeroes ++);

  ks=MAX_RSA_MODULUS_LEN-zeroes;

  sprintf(buf+strlen(buf),"%02X",ks>>8);
  if (++lc % 30 == 0) sprintf(buf+strlen(buf),"\r\n");
  sprintf(buf+strlen(buf),"%02X",ks&0xff);
  if (++lc % 30 == 0) sprintf(buf+strlen(buf),"\r\n");

  for (x = 0; x < ks; x ++)
  {
    sprintf(buf+strlen(buf),"%02X",kp->publicExponent[MAX_RSA_MODULUS_LEN-ks+x]);
    if (++lc % 30 == 0) sprintf(buf+strlen(buf),"\r\n");
  }
  if (lc % 30) sprintf(buf+strlen(buf),"\r\n");
  sprintf(buf+strlen(buf),"WASTE_PUBLIC_KEY_END\r\n");
  abuf = (char *)malloc(strlen(buf)+1);
  strcpy(abuf, buf);
  return abuf;
}
